Description

Certain caches are static once they've been filled with data. One example is the classes cache in FLOW3 – after all proxy classes
have been compiled, the cache must never be touched again in Production context.

Especially in the mentioned case, a cache backend could work with greatly improved performance if it knew that no changes are to be
expected. It could create an index of existing cache entries which is loaded upfront. Existing cache entries could then be loaded right
away without the need to check for expiry times or existence.

Related issues:
related to Core - Feature # 39430: Update cache framework to latest FLOW3 ver... Resolved 2014-04-17

Associated revisions
Revision c94e6f17 - 2011-12-09 10:03 - Robert Lemke

[FEATURE] Freezable Cache Backend

This introduces a new type of cache backends which supports freezing.
In a frozen state no modifications are allowed and thus enables the
cache implementation to optimize its tasks for speed.

The FileBackend was extended to support freezing and is now used for
the class cache in Production context. Measured on the blog example,
this change improved number of transactions per second by 29 %.

Change-Id: I1bd212157516875507ce7677515d14e8a611aa73
Resolves: #32398
Releases: 1.1

History
#1 - 2011-12-08 16:05 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7162

#2 - 2011-12-08 16:56 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7162

#3 - 2011-12-08 18:57 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7162

#4 - 2011-12-09 09:59 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7162

#5 - 2011-12-09 10:03 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7162

#6 - 2011-12-09 10:06 - Robert Lemke
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:c94e6f1747e607a3fc8e2da2cecbfc15ebf443b8.

#7 - 2011-12-09 12:30 - Christopher Hlubek

There is no way to re-compile classes in production anymore:

./flow3 flow3:core:compile gives an error The cache "FLOW3_Object_Classes" is already frozen. since the class cache is frozen. We need to
"unfreeze" it on compilation.

#8 - 2011-12-21 12:38 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 beta 1
